//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int    T3Period     = 14;
extern int    T3Price      = PRICE_CLOSE;
extern bool   T3Original   = false;

double t3[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,t3);
   return(0);
}

//
//
//
//
//

int start()
{
   int i,limit,countedBars = IndicatorCounted();

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = MathMin(Bars-countedBars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >=0; i--) t3[i] = iT3r(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Original,i,0);
	return(0);	
 }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

#define _maWorkBufferx7 7
double workT3r[][_maWorkBufferx7];

//
//
//
//
//

double iT3r(double price, double period, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3r,0) != Bars) ArrayResize(workT3r,Bars); instanceNo *= 7; i = Bars-i-1;
   if (original)
         double alpha = 2.0 / (1.0 + period);
   else         alpha = 2.0 / (2.0 + (period-1.0)/2.0);   
   
   //
   //
   //
   //
   //

      workT3r[i][instanceNo] = price;
         static double rs_len   = 0; 
         static double rs_SumX  = 0;
         static double rs_SumX2 = 0;
            if (rs_len != period)
            {
               rs_len   = period;
               rs_SumX  = 0; for(int k=0; k<period; k++) rs_SumX  +=  k+1;
               rs_SumX2 = 0; for(    k=0; k<period; k++) rs_SumX2 += (k+1)*(k+1);
            }         
     
         //
         //
         //
         //
         //
      
         double rs_SumY  = 0;
         double rs_SumY2 = 0;
         double rs_SumXY = 0;

            for(k=0; k<period; k++)
            {
               double tprice = workT3r[i-k][instanceNo];
                  rs_SumY  +=         tprice;
                  rs_SumY2 += MathPow(tprice,2);
                  rs_SumXY +=   (k+1)*tprice;
            }

         double Q1  = rs_SumXY - rs_SumX*rs_SumY/period;
         double Q2  = rs_SumX2 - rs_SumX*rs_SumX/period;
         double Q3  = rs_SumY2 - rs_SumY*rs_SumY/period;
         double hot = 0; 
            if( Q2*Q3 != 0 ) hot = MathMax(1.0-Q1*Q1/(Q2*Q3),0.01);

      //
      //
      //
      //
      //
       
      workT3r[i][instanceNo+1] = workT3r[i-1][instanceNo+1]+alpha*(price                   -workT3r[i-1][instanceNo+1]);
      workT3r[i][instanceNo+2] = workT3r[i-1][instanceNo+2]+alpha*(workT3r[i][instanceNo+1]-workT3r[i-1][instanceNo+2]);
                         price = (1.0+hot)*workT3r[i][instanceNo+1]-hot*workT3r[i][instanceNo+2];
      workT3r[i][instanceNo+3] = workT3r[i-1][instanceNo+3]+alpha*(price                   -workT3r[i-1][instanceNo+3]);
      workT3r[i][instanceNo+4] = workT3r[i-1][instanceNo+4]+alpha*(workT3r[i][instanceNo+3]-workT3r[i-1][instanceNo+4]);
                         price = (1.0+hot)*workT3r[i][instanceNo+3]-hot*workT3r[i][instanceNo+4];
      workT3r[i][instanceNo+5] = workT3r[i-1][instanceNo+5]+alpha*(price                   -workT3r[i-1][instanceNo+5]);
      workT3r[i][instanceNo+6] = workT3r[i-1][instanceNo+6]+alpha*(workT3r[i][instanceNo+5]-workT3r[i-1][instanceNo+6]);
                         return((1.0+hot)*workT3r[i][instanceNo+5]-hot*workT3r[i][instanceNo+6]);
}